{ Autor: Tomasz Kolinko    }
{        tom@kolinko.pl    }
{        http://Kolinko.pl }
{ TRichLabel component     }
{ See instructions below.  }
{ Copyright information:   }
{ This component is Cardware.
  It means that if you want to use it then you have
  to send a nice postcard with photo from your place
  to an address:
   Tomasz Kolinko
   ul. Szolc-Rogozinskiego 9/53
   02-777 Warszawa
   POLAND
  I propably won't publish any more components if I won't get
  any postcards. And you don't want that, right?

  You may edit those sources if you want, you need to send me
  modified versions of them.

  You may use this component for any commercial or not purpose

  You may not modify this anything between begginning of this
  file and end of this comment.

  You ought to include me in credits. This is not required though.

  You may send me money if you want to :)

             Tomasz Kolinko
             05-17-2003
}

{$DEFINE JPEG}
{$DEFINE RXGIF}
{
 Remove above if you don't have Jpeg or RxGIF installed
 As far as I know Jpeg is installed by default in Delphi6.
 Without above you won't be able to use jpeg or gif images
 in your RichLabel.

 If you want to change your text properties you need to put
 one of folowing commands in a caption.
 *they must begin with newline to work*

   text properties
  #j0/1 - justify; default on; when selected it justifies text to left and to
                               right
  #b0/1 - bold
  #i0/1 - italic
  #sxx - size
  #c - center
  #l - left
  #r - right
  #nxx - iNdent
  #mxx - right Margin
  #lxxx - interLine - distance between lines in percents, 120 default
   image properties
  #k0/1 - bacK - image will be displayed beneath the text

 To insert an image into text use
  *ic:\optional\path\filename.jpg

 To insert a blank line into text type
  .
 as an only character in that line. For some unknown to me reasons
 IDE cuts off all blank lines when editing caption via IDE.

 Example usage:
--cut--
#c
*ihello.jpg
#s20
#b
TRichLabel demo
#l
#i1
#s10
#n50
#m30
"Those heights by great men reached and kept were not obtained by sudden flight, but they, while their companions slept were toiling upward in the night."
#i0
#m50
#r
Henry Wadsworth Longfellow
#l
#n10
#u1
#s12
.
Don't forget!
#s10
#u0
#m5
#j0
TRichLabel is Cardware. If you want to use it then send some nice postcard with a nice photo from your place to:
#n15
Tomasz Kolinko
ul. Szolc-Rogozinskiego 9/53
02-777 Warsaw
POLAND
--cut--
}



unit RichLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Graphics
  {$IFDEF JPEG}
  , jpeg
  {$ENDIF}
  {$IFDEF RXGIF}
  , RxGIF
  {$ENDIF}
  ;

type
  TRichLabel = class(TLabel)
  private
    { Private declarations }
    Pictures: array of TPicture;
    FileNames: array of string;
    // assigns pictures id with filename of picture
    function LoadImage(fname:string):TPicture;
    // loads image from disk
    function GetImage(fname:string):TPicture;
    // gets image from the pictures array or from disk
  protected
    { Protected declarations }
    procedure AdjustBounds; override;
  public
    { Public declarations }
    procedure Paint; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

function TRichLabel.loadImage;
begin
 result:=TPicture.Create;
 {$IFDEF JPEG}
 result.RegisterFileFormat('.jpg','Jpeg image',TJPegImage);
 result.RegisterFileFormat('.jpeg','Jpeg image',TJPegImage);
 {$ENDIF}
 {$IFDEF RXGIF}
 result.RegisterFileFormat('.gif','Gif image',TGifImage);
 {$ENDIF}
 if fileexists(fname) then
  result.LoadFromFile(fname)
 else
   begin
    result.bitmap:=TBitmap.Create;
    with result.bitmap do
     begin
      Width:=20;
      Height:=20;
      Canvas.MoveTo(0,0);
      canvas.LineTo(width,height);
      canvas.MoveTo(width,0);
      canvas.LineTo(0,height);
     end;
   end;
end;

function TRichLabel.GetImage;
 function FindFileName(fn:string):integer;
 var
  i:integer;
 begin
  for i:=0 to length(filenames)-1 do
   if uppercase(filenames[i])=uppercase(fn) then
    begin
     result:=i;
     exit;
    end;
  result:=length(filenames);
 end;

var
 idx:integer;
begin
 idx:=FindFileName(fname);
 if idx>=length(Pictures) then
  begin
   setlength(pictures,idx+1);
   setlength(filenames,idx+1);
   filenames[idx]:=fname;
   pictures[idx]:=LoadImage(fname);
  end;
 result:=Pictures[idx];
end;

procedure TRichLabel.ADjustBounds;
begin

end;

procedure TRichLabel.Paint;
var
 i:integer;
 lines:TStringList;
 rect:TRect;
 align:Talignment;
 interline:integer;
 lJustify:integer;
 imageBack:boolean;
 
 procedure DrawSpecial(s:string);
 var
  pic:TPicture;
  x:integer;
 begin
  assert(s[1]='*');
  if (lowercase(s[2])='i') then
   begin
    pic:=GetImage(copy(s,3,length(s)));
    if align=taLeftJustify then
     x:=rect.left
    else if align=taCenter then
     x:=rect.left+(rect.right-rect.left-pic.graphic.Width) div 2
    else // align=taRightJustify 
     x:=rect.right-pic.graphic.Height;
    canvas.Draw(x,rect.Top,pic.graphic);
    if not imageBack then
     inc(rect.top,pic.Graphic.Height);
   end;
 end;

 procedure ProcessAttrs(s:String);
  procedure Split(s:string; var pol:char;var parm:integer);
  begin
   assert(length(s)>1);
   assert(s[1] in ['#']);
   pol:=s[2];
   if length(s)>2 then
    try
     parm:=strtoint(copy(s,3,length(s)))
    except // ide hang a few times when I
           // entered non-numeric stuff after command
     parm:=0;
    end
   else
    parm:=0;
  end;

  procedure OnOff(fs:TFontStyle;wl:boolean);
  begin
   if wl then
    canvas.font.Style:=canvas.font.Style + [fs]
   else
    canvas.font.Style:=canvas.font.Style - [fs];
  end;
 {
  #j0/1 - justify default on
  #b0/1 - bold
  #i0/1 - italic
  #sxx - size
  #c - center
  #l - left
  #r - right
  #nxx - iNdent
  #mxx - right Margin 
  #lxxx - interLine
  // image properties
  #k0/1 - bacK - image will be displayed beneath the text
 }
  var
   pol:char;
   parm:integer;
 begin
  Split(s,pol,parm);
  case lowercase(pol)[1] of
   'j':lJustify:=parm;
   'b':OnOff(fsBold,parm=1);
   'i':OnOff(fsItalic,parm=1);
   'u':OnOff(fsUnderline,parm=1);
   'c':Align:=taCenter;
   'l':ALign:=taLeftJustify;
   'r':Align:=taRightJustify;
   'n':rect.left:=parm;
   'm':rect.right:=width-parm;
   's':canvas.font.Size:=parm;
   'k':imageBack:=(parm=1);
  end;
 end;

 procedure DrawLine(s:string);
  function WC(ch:char):boolean;
  begin
   result:= ch in [' ','-'];
  end;

  function ClipText(var s,t:string):boolean;
  var
   i:integer;
  begin
   s:=s+' ';
   i:=length(s);
   while (i>0) and (not WC(s[i])
     or (Canvas.TextWidth(copy(s,1,i))>Rect.Right-Rect.Left)) do
      dec(i);
   if i=0 then begin t:=s; s:=''; end
    else
     begin
      t:=copy(s,1,i-1);
      delete(s,1,i);
     end;
   result:=t<>'';
  end;

  procedure Justify(var s:string);
  var
   p:integer;
   procedure AddSpace(var s:String);
   var pp:integer;
   begin
    inc(p);
    pp:=p;    
    p:=pos(' ',copy(s,p,length(s)))+p;
    if p=pp then p:=0;
    if p>0 then
     insert(' ',s,p)
    else
     s:=s+' ';
   end;

  begin
  p:=0;
   while canvas.TextWidth(s)<rect.right-rect.left-canvas.textwidth(' ') do
    AddSpace(s);
  end;

 var
  t:string;
 begin
  while ClipText(s,t) do
   begin
    if (Align<>taCenter) and (s<>'') and (lJustify>0) then
     Justify(t);
    if Align=taleftJustify then
     Canvas.TextOut(rect.left,rect.top,t)
    else if Align=taRightJustify then
     Canvas.TextOut(rect.right-canvas.textwidth(t),rect.Top,t)
    else if Align=taCenter then
     Canvas.TextOut(rect.left + (rect.right-rect.left-canvas.TextWidth(t))div 2,rect.top,t);
    inc(rect.top,round(canvas.textheight('|')*(interline/100)));
   end;
 end;

begin
 canvas.Brush.Style:=bsClear;
 canvas.font:=font;
 rect.Left:=0; rect.right:=width;
 rect.top:=0; rect.Bottom:=height;
 align:=alignment;
 lines:=TStringList.Create;
 lines.Text:=caption;
 interline:=120;
 imageBack:=false;
 for i:=0 to lines.Count-1 do
  begin
   if lines[i]='.' then inc(rect.top,canvas.TextHeight('|'))
   else if lines[i][1]='#' then ProcessAttrs(lines[i])
   else if lines[i][1]='*' then DrawSpecial(lines[i])
   else DrawLine(lines[i]);
  end;
 if autosize and (height<>rect.top) then
  height:=rect.top;
end;

procedure Register;
begin
  RegisterComponents('Additional', [TRichLabel]);
end;

end.
